{
  lib,
  config,
  pkgs,
  ...
}: let
  cfg = config.myConfig.qemu;
in {
  options.myConfig.qemu = {
    enable = lib.mkEnableOption "qemu";
    kvm = lib.mkEnableOption "kvm for faster emulation of x86";
  };

  config = lib.mkIf cfg.enable {
    virtualisation.
    libvirtd = {
      enable = true;
      qemu = {
        package = lib.mkIf cfg.kvm pkgs.qemu_kvm;
        runAsRoot = true;
        swtpm.enable = true;
        ovmf = {
          enable = true;
          packages = [
            (pkgs.OVMF.override {
              secureBoot = true;
              tpmSupport = true;
            })
            .fd
          ];
        };
      };
    };
  };
}
